--[[
  MP4 対応 Bravia 用スクリプト
  
  2012.5.2
  ・DVDタイトルリストの表示に対応。
  ・DVDの音声が英語以外でも日本語字幕表示再生に対応。優先音声＋日本語字幕表示で再生します。
]]


-- DVDのタイトルリストをタイトル番号、言語選択順に表示する場合は true にしてください
-- 言語選択、タイトル番号順に表示する場合は false にしてください
DVDSortTitleNo = false

-- H264 を Mpeg TS にトランスコード(Remux)する場合は true にしてください
-- H264 も通常のトランスコードでよい場合は false にしてください。
H264ToMpegTS = false


-- この機種がサポートしているメディア情報のリスト
SUPPORT_MEDIA_LIST = {
  "image/jpeg:DLNA.ORG_PN=JPEG_LRG",
  "image/jpeg:DLNA.ORG_PN=JPEG_MED",
  "image/jpeg:DLNA.ORG_PN=JPEG_SM",
  "audio/L16:DLNA.ORG_PN=LPCM",
  "audio/mpeg:DLNA.ORG_PN=MP3",
  "audio/x-ms-wma:DLNA.ORG_PN=WMABASE",
  "audio/x-ms-wma:DLNA.ORG_PN=WMAFULL",
  "video/vnd.dlna.mpeg-tts:DLNA.ORG_PN=AVC_TS_HD_60_AC3_T;SONY.COM_PN=AVC_TS_HD_60_AC3_T",
  "video/vnd.dlna.mpeg-tts:DLNA.ORG_PN=AVC_TS_HD_50_AC3_T;SONY.COM_PN=AVC_TS_HD_50_AC3_T",
  "video/vnd.dlna.mpeg-tts:DLNA.ORG_PN=AVC_TS_HD_60_AC3;SONY.COM_PN=AVC_TS_HD_60_AC3",
  "video/vnd.dlna.mpeg-tts:DLNA.ORG_PN=AVC_TS_HD_50_AC3;SONY.COM_PN=AVC_TS_HD_50_AC3",
  "video/mpeg:DLNA.ORG_PN=AVC_TS_HD_60_AC3_ISO;SONY.COM_PN=AVC_TS_HD_60_AC3_ISO",
  "video/mpeg:DLNA.ORG_PN=AVC_TS_HD_50_AC3_ISO;SONY.COM_PN=AVC_TS_HD_50_AC3_ISO",
  "video/vnd.dlna.mpeg-tts:DLNA.ORG_PN=AVC_TS_HD_EU_T",
  "video/vnd.dlna.mpeg-tts:DLNA.ORG_PN=AVC_TS_HD_EU",
  "video/mpeg:DLNA.ORG_PN=AVC_TS_HD_EU_ISO",
  "video/vnd.dlna.mpeg-tts:DLNA.ORG_PN=MPEG_TS_HD_NA_T",
  "video/vnd.dlna.mpeg-tts:DLNA.ORG_PN=MPEG_TS_HD_KO_T",
  "video/vnd.dlna.mpeg-tts:DLNA.ORG_PN=MPEG_TS_HD_NA",
  "video/vnd.dlna.mpeg-tts:DLNA.ORG_PN=MPEG_TS_HD_KO",
  "video/mpeg:DLNA.ORG_PN=MPEG_TS_HD_NA_ISO",
  "video/mpeg:DLNA.ORG_PN=MPEG_TS_HD_KO_ISO",
  "video/vnd.dlna.mpeg-tts:DLNA.ORG_PN=MPEG_TS_JP_T",
  "video/vnd.dlna.mpeg-tts:DLNA.ORG_PN=MPEG_TS_HD_NA_MPEG1_L2_T",
  "video/vnd.dlna.mpeg-tts:DLNA.ORG_PN=MPEG_TS_HD_60_L2_T;SONY.COM_PN=HD2_60_T",
  "video/vnd.dlna.mpeg-tts:DLNA.ORG_PN=MPEG_TS_HD_50_L2_T;SONY.COM_PN=HD2_50_T",
  "video/mpeg:DLNA.ORG_PN=MPEG_TS_HD_NA_MPEG1_L2_ISO",
  "video/mpeg:DLNA.ORG_PN=MPEG_TS_HD_60_L2_ISO;SONY.COM_PN=HD2_60_ISO",
  "video/mpeg:DLNA.ORG_PN=MPEG_TS_HD_50_L2_ISO;SONY.COM_PN=HD2_50_ISO",
  "video/vnd.dlna.mpeg-tts:DLNA.ORG_PN=MPEG_TS_SD_60_AC3_T",
  "video/vnd.dlna.mpeg-tts:DLNA.ORG_PN=MPEG_TS_SD_50_AC3_T",
  "video/vnd.dlna.mpeg-tts:DLNA.ORG_PN=MPEG_TS_SD_NA_T",
  "video/vnd.dlna.mpeg-tts:DLNA.ORG_PN=MPEG_TS_SD_KO_T",
  "video/vnd.dlna.mpeg-tts:DLNA.ORG_PN=MPEG_TS_SD_NA",
  "video/vnd.dlna.mpeg-tts:DLNA.ORG_PN=MPEG_TS_SD_KO",
  "video/mpeg:DLNA.ORG_PN=MPEG_TS_SD_NA_ISO",
  "video/mpeg:DLNA.ORG_PN=MPEG_TS_SD_KO_ISO",
  "video/vnd.dlna.mpeg-tts:DLNA.ORG_PN=MPEG_TS_SD_EU_T",
  "video/vnd.dlna.mpeg-tts:DLNA.ORG_PN=MPEG_TS_SD_EU",
  "video/mpeg:DLNA.ORG_PN=MPEG_TS_SD_EU_ISO",
  "video/vnd.dlna.mpeg-tts:DLNA.ORG_PN=MPEG_TS_SD_JP_MPEG1_L2_T",
  "video/vnd.dlna.mpeg-tts:DLNA.ORG_PN=MPEG_TS_SD_NA_MPEG1_L2_T",
  "video/vnd.dlna.mpeg-tts:DLNA.ORG_PN=MPEG_TS_SD_60_L2_T",
  "video/vnd.dlna.mpeg-tts:DLNA.ORG_PN=MPEG_TS_SD_50_L2_T",
  "video/mpeg:DLNA.ORG_PN=MPEG_TS_SD_NA_MPEG1_L2_ISO",
  "video/mpeg:DLNA.ORG_PN=MPEG_PS_NTSC",
  "video/mpeg:DLNA.ORG_PN=MPEG_PS_PAL",
  "video/mpeg:DLNA.ORG_PN=MPEG1",
  "video/x-ms-wmv:DLNA.ORG_PN=WMVMED_BASE",
  "video/x-ms-wmv:DLNA.ORG_PN=WMVMED_FULL",
  "video/x-ms-wmv:DLNA.ORG_PN=WMVHIGH_FULL",
  "video/x-ms-wmv:DLNA.ORG_PN=WMVSPLL_BASE",
  "video/x-ms-wmv:DLNA.ORG_PN=WMVSPML_BASE",
  "video/x-ms-asf:DLNA.ORG_PN=VC1_ASF_AP_L1_WMA",
  "video/x-ms-asf:DLNA.ORG_PN=VC1_ASF_AP_L2_WMA",
  "video/vnd.dlna.mpeg-tts:DLNA.ORG_PN=AVC_TS_HD_24_AC3_T;SONY.COM_PN=AVC_TS_HD_24_AC3_T",
  "video/vnd.dlna.mpeg-tts:DLNA.ORG_PN=AVC_TS_HD_24_AC3;SONY.COM_PN=AVC_TS_HD_24_AC3",
  "video/mpeg:DLNA.ORG_PN=AVC_TS_HD_24_AC3_ISO;SONY.COM_PN=AVC_TS_HD_24_AC3_ISO",
  "video/vnd.dlna.mpeg-tts:DLNA.ORG_PN=AVC_TS_JP_AAC_T",
  "video/x-mp2t-mphl-188:*",
  "image/jpeg:*",
  "audio/mpeg:*",
  "audio/L16:*",
  "audio/x-ms-wma:*",
  "video/mpeg:*",
  "video/vnd.dlna.mpeg-tts:*",
  "video/mp4:*",
  "video/x-ms-wmv:*",
  "video/x-ms-asf:*"
}


--[[
 GetMimeType 関数

 メディアファイルに応じたメディア情報を返す。

 引数：
   fname: ファイル名
   minfo: MediaInfo.dll などから得られた情報
]]
function GetMimeType(fname, minfo)
  
  if minfo.General.Format == "" then return "" end
  
  if minfo.General.Format == "NowRecording" then
    -- 録画中のファイルは MPEG-TS と仮定する。
    return "video/mpeg:"
           .."DLNA.ORG_PN=MPEG_TS_HD_60_L2_ISO;"
           .."SONY.COM_PN=HD2_60_ISO;"
           .."DLNA.ORG_FLAGS=8d700000000000000000000000000000;"
           .."DLNA.ORG_OP=11;DLNA.ORG_CI=0"
  end

  local ext = string.lower(string.match(fname, ".*%.([^.]+)$"))

  if ext == "jpg" then
    return "image/jpeg:DLNA.ORG_PN=JPEG_LRG;"
     .."DLNA.ORG_FLAGS=8cf00000000000000000000000000000"
  end

  if ext == "mp3" then
    return "audio/mpeg:DLNA.ORG_PN=MP3;"
     .."DLNA.ORG_FLAGS=8d700000000000000000000000000000"
  end
  
  if ext == "wav" then
    return "audio/L16:DLNA.ORG_PN=LPCM;"
     .."DLNA.ORG_FLAGS=8d700000000000000000000000000000"
  end
  
  if minfo.Video.Format == "" then return "" end
  
  local res = "video/x-mp2t-mphl-188:*;DLNA.ORG_OP=11;DLNA.ORG_CI=0"
  local fr = string.sub(minfo.Video.FrameRate, 1, 2)

  if minfo.General.Format == "MPEG-4" then
    return "video/mp4:*;"
     .."DLNA.ORG_FLAGS=8d700000000000000000000000000000;"
     .."DLNA.ORG_OP=11;DLNA.ORG_CI=0"
  end

  if minfo.Video.Format == "MPEG Video" or minfo.Video.Format == "AVC" then
    if minfo.General.Format == "BDAV" then
      -- NTSC?
      if fr == "29" or fr == "59" or minfo.Video.Standard == "NTSC" then
        res = "video/vnd.dlna.mpeg-tts:"
         .."DLNA.ORG_PN=MPEG_TS_JP_T;"
         .."DLNA.ORG_FLAGS=8d700000000000000000000000000000;"
         .."DLNA.ORG_OP=11;DLNA.ORG_CI=0"

        -- AVCHD?
        if minfo.Video.Format == "AVC" then
          if minfo.Audio.Format == "AC-3" then
            res = "video/vnd.dlna.mpeg-tts:"
             .."DLNA.ORG_PN=AVC_TS_HD_60_AC3_T;"
             .."SONY.COM_PN=AVC_TS_HD_60_AC3_T;"
             .."DLNA.ORG_FLAGS=8d700000000000000000000000000000;"
             .."DLNA.ORG_OP=11;DLNA.ORG_CI=0"
          elseif minfo.Audio.Format == "AAC" then
            res = "video/vnd.dlna.mpeg-tts:"
             .."DLNA.ORG_PN=AVC_TS_JP_AAC_T;"
             .."DLNA.ORG_FLAGS=8d700000000000000000000000000000;"
             .."DLNA.ORG_OP=11;DLNA.ORG_CI=0"
          end
        else
          -- HD?
          if tonumber(minfo.Video.Width) > 1000 then
            -- AAC etc.
            res = "video/vnd.dlna.mpeg-tts:"
             .."DLNA.ORG_PN=MPEG_TS_HD_60_L2_T;"
             .."SONY.COM_PN=HD2_60_T;"
             .."DLNA.ORG_FLAGS=8d700000000000000000000000000000;"
             .."DLNA.ORG_OP=11;DLNA.ORG_CI=0"
          else
            -- AC3?
            if minfo.Audio.Format == "AC-3" then
              res = "video/vnd.dlna.mpeg-tts:"
               .."DLNA.ORG_PN=MPEG_TS_SD_60_AC3_T;"
               .."DLNA.ORG_FLAGS=8d700000000000000000000000000000;"
               .."DLNA.ORG_OP=11;DLNA.ORG_CI=0"
            else
              -- AAC etc.
              res = "video/vnd.dlna.mpeg-tts:"
               .."DLNA.ORG_PN=MPEG_TS_SD_60_L2_T;"
               .."DLNA.ORG_FLAGS=8d700000000000000000000000000000;"
               .."DLNA.ORG_OP=11;DLNA.ORG_CI=0"
            end
          end
        end
      
      -- 24p(not PAL)?
      elseif fr ~= "25" and fr ~= "50" then
        res = "video/vnd.dlna.mpeg-tts:"
         .."DLNA.ORG_PN=AVC_TS_HD_24_AC3_T;"
         .."SONY.COM_PN=AVC_TS_HD_24_AC3_T;"
         .."DLNA.ORG_FLAGS=8d700000000000000000000000000000;"
         .."DLNA.ORG_OP=11;DLNA.ORG_CI=0"
      end
      
      return res

    elseif minfo.General.Format == "MPEG-TS" then
      -- NTSC?
      if fr == "29" or fr == "59" or minfo.Video.Standard == "NTSC" then
        -- AVCHD?
        if minfo.Video.Format == "AVC" --[[and minfo.Audio.Format == "AC-3"]] then
          -- [[
          res = "video/mpeg:"
           .."DLNA.ORG_PN=AVC_TS_HD_60_AC3_ISO;"
           .."SONY.COM_PN=AVC_TS_HD_60_AC3_ISO;"
           .."DLNA.ORG_FLAGS=8d700000000000000000000000000000;"
           .."DLNA.ORG_OP=11;DLNA.ORG_CI=0"
          -- ]]
          --[[ これも同じ？
          res = "video/vnd.dlna.mpeg-tts:"
           .."DLNA.ORG_PN=AVC_TS_HD_60_AC3;"
           .."SONY.COM_PN=AVC_TS_HD_60_AC3;"
           .."DLNA.ORG_FLAGS=8d700000000000000000000000000000;"
           .."DLNA.ORG_OP=11;DLNA.ORG_CI=0"
          -- ]]
        else
          res = "video/mpeg:"
           .."DLNA.ORG_PN=MPEG_TS_HD_60_L2_ISO;"
           .."SONY.COM_PN=HD2_60_ISO;"
           .."DLNA.ORG_FLAGS=8d700000000000000000000000000000;"
           .."DLNA.ORG_OP=11;DLNA.ORG_CI=0"
        end

      -- 24p(not PAL)?
      elseif fr ~= "25" and fr ~= "50" then
        -- [[
        res = "video/mpeg:"
         .."DLNA.ORG_PN=AVC_TS_HD_24_AC3_ISO;"
         .."SONY.COM_PN=AVC_TS_HD_24_AC3_ISO;"
         .."DLNA.ORG_FLAGS=8d700000000000000000000000000000;"
         .."DLNA.ORG_OP=11;DLNA.ORG_CI=0"
        -- ]]
        --[[ これも同じ？
        res = "video/vnd.dlna.mpeg-tts:"
         .."DLNA.ORG_PN=AVC_TS_HD_24_AC3;"
         .."SONY.COM_PN=AVC_TS_HD_24_AC3;"
         .."DLNA.ORG_FLAGS=8d700000000000000000000000000000;"
         .."DLNA.ORG_OP=11;DLNA.ORG_CI=0"
        -- ]]
      end
      return res
    end
  end

  if minfo.General.Format == "MPEG-PS"
   -- NTSC?
   and (fr == "29" or fr == "59" or minfo.Video.Standard == "NTSC")
   -- SD?
   and tonumber(minfo.Video.Width) < 1000
   -- アスペクト比=16/9 ?
   and minfo.Video.DisplayAspectRatio == "1.778" then

    return "video/mpeg:DLNA.ORG_PN=MPEG_PS_NTSC;"
     .."DLNA.ORG_FLAGS=8d700000000000000000000000000000;"
     .."DLNA.ORG_OP=11;DLNA.ORG_CI=0"

  end
  
  if H264ToMpegTS and minfo.Video.Format == "AVC"
   -- CFR?
   and minfo.Video.FrameRate_Mode ~= "VFR"
   -- アスペクト比=16/9 ?
   and minfo.Video.DisplayAspectRatio == "1.778" then

    -- NTSC?
    if  fr == "29" or fr == "59" or minfo.Video.Standard == "NTSC" then
      return "video/mpeg:"
       .."DLNA.ORG_PN=AVC_TS_HD_60_AC3_ISO;"
       .."SONY.COM_PN=AVC_TS_HD_60_AC3_ISO;"
       .."DLNA.ORG_FLAGS=8d700000000000000000000000000000;"
       .."DLNA.ORG_OP=11;DLNA.ORG_CI=0"
       ..":::TRANS:::" -- トランスコードが必要なことをBMSに伝える
     
       --[[
        つぶやき：AVC_TS_JP_AAC_T とかも使えば AAC などにも対応できるかも。
        もっとも、音声変換はもともと負荷が低いのであまり意味がないかも。
       ]]
    end
    
    -- 24p(not PAL)?
    if fr ~= "25" and fr ~= "50" and minfo.Video.Standard ~= "PAL" then
      return "video/mpeg:"
       .."DLNA.ORG_PN=AVC_TS_HD_24_AC3_ISO;"
       .."SONY.COM_PN=AVC_TS_HD_24_AC3_ISO;"
       .."DLNA.ORG_FLAGS=8d700000000000000000000000000000;"
       .."DLNA.ORG_OP=11;DLNA.ORG_CI=0"
       ..":::TRANS:::" -- トランスコードが必要なことをBMSに伝える
    end
  end

  return "video/mpeg:DLNA.ORG_PN=MPEG_PS_NTSC;"
   .."DLNA.ORG_FLAGS=8d700000000000000000000000000000;"
   .."DLNA.ORG_OP=11;DLNA.ORG_CI=0"
   ..":::TRANS:::" -- トランスコードが必要なことをBMSに伝える
end


--[[
 GetTranscodeCommand 関数
 
 トランスコードのコマンドを返す。

 引数：
   fname: ファイル名
   minfo: MediaInfo.dll などから得られた情報
]]
function GetTranscodeCommand(fname, minfo)

  local aspect = minfo.Video.DisplayAspectRatio
  if aspect == "" then aspect = "1.333" end
  --print("\r\nDEBUG: "..fname.." aspect="..aspect.."\r\n")
  local w = minfo.Video.Width
  local h = minfo.Video.Height

  -- この機種ではサイズによりアスペクト比を判定しているみたいなので
  -- mpeg2 のサイズとアスペクト比を固定にする。
  w = "720" h = "480"
  local vfs0 = "scale="..w..":"..h
  if aspect ~= "1.778" then
    local sw = w
    local sh = h
    if tonumber(aspect) < 1.778 then
      sw = math.floor(w / 1.778 * aspect + 0.5)
    else
      sh = math.floor(h * 1.778 / aspect + 0.5)
    end
    vfs0 = "scale="..sw..":"..sh..",expand="..w..":"..h
    aspect = "1.778"
  end

  local vfs = vfs0 .. ",pp=l5,harddup"


  -- DVDトランスコード用変数
  dvdopt = [[ -o "$_out_$" -oac lavc -ovc lavc -of mpeg -mpegopts format=dvd:tsaf
          -vf ]]..vfs..[[ -srate 48000 -af lavcresample=48000
          -ofps 30000/1001
          -channels 6
          -lavcopts vcodec=mpeg2video:vrc_buf_size=1835:vrc_maxrate=9800:vbitrate=5000:keyint=18:vstrict=0:acodec=ac3:abitrate=192:aspect=]]
          ..aspect
  local slangjalist = false
  local alangjalist = false
  local dvdres = ""

  -- DVDのトランスコード
  if minfo.General.Format == "ISO DVD" then
    dvdlength = {
      minfo.DVD.LENGTH1,minfo.DVD.LENGTH2,minfo.DVD.LENGTH3,minfo.DVD.LENGTH4,minfo.DVD.LENGTH5,
      minfo.DVD.LENGTH6,minfo.DVD.LENGTH7,minfo.DVD.LENGTH8,minfo.DVD.LENGTH9,minfo.DVD.LENGTH10,
      minfo.DVD.LENGTH11,minfo.DVD.LENGTH12,minfo.DVD.LENGTH13,minfo.DVD.LENGTH14,minfo.DVD.LENGTH15,
      minfo.DVD.LENGTH16,minfo.DVD.LENGTH17,minfo.DVD.LENGTH18,minfo.DVD.LENGTH19,minfo.DVD.LENGTH20,
      minfo.DVD.LENGTH21,minfo.DVD.LENGTH22,minfo.DVD.LENGTH23,minfo.DVD.LENGTH24,minfo.DVD.LENGTH25,
      minfo.DVD.LENGTH26,minfo.DVD.LENGTH27,minfo.DVD.LENGTH28,minfo.DVD.LENGTH29,minfo.DVD.LENGTH30,
      minfo.DVD.LENGTH31,minfo.DVD.LENGTH32,minfo.DVD.LENGTH33,minfo.DVD.LENGTH34,minfo.DVD.LENGTH35,
      minfo.DVD.LENGTH36,minfo.DVD.LENGTH37,minfo.DVD.LENGTH38,minfo.DVD.LENGTH39,minfo.DVD.LENGTH40,
      minfo.DVD.LENGTH41,minfo.DVD.LENGTH42,minfo.DVD.LENGTH43,minfo.DVD.LENGTH44,minfo.DVD.LENGTH45,
      minfo.DVD.LENGTH46,minfo.DVD.LENGTH47,minfo.DVD.LENGTH48,minfo.DVD.LENGTH49,minfo.DVD.LENGTH50,
      minfo.DVD.LENGTH51,minfo.DVD.LENGTH52,minfo.DVD.LENGTH53,minfo.DVD.LENGTH54,minfo.DVD.LENGTH55,
      minfo.DVD.LENGTH56,minfo.DVD.LENGTH57,minfo.DVD.LENGTH58,minfo.DVD.LENGTH59,minfo.DVD.LENGTH60,
      minfo.DVD.LENGTH61,minfo.DVD.LENGTH62,minfo.DVD.LENGTH63,minfo.DVD.LENGTH64,minfo.DVD.LENGTH65,
      minfo.DVD.LENGTH66,minfo.DVD.LENGTH67,minfo.DVD.LENGTH68,minfo.DVD.LENGTH69,minfo.DVD.LENGTH70,
      minfo.DVD.LENGTH71,minfo.DVD.LENGTH72,minfo.DVD.LENGTH73,minfo.DVD.LENGTH74,minfo.DVD.LENGTH75,
      minfo.DVD.LENGTH76,minfo.DVD.LENGTH77,minfo.DVD.LENGTH78,minfo.DVD.LENGTH79,minfo.DVD.LENGTH80,
      minfo.DVD.LENGTH81,minfo.DVD.LENGTH82,minfo.DVD.LENGTH83,minfo.DVD.LENGTH84,minfo.DVD.LENGTH85,
      minfo.DVD.LENGTH86,minfo.DVD.LENGTH87,minfo.DVD.LENGTH88,minfo.DVD.LENGTH89,minfo.DVD.LENGTH90,
      minfo.DVD.LENGTH91,minfo.DVD.LENGTH92,minfo.DVD.LENGTH93,minfo.DVD.LENGTH94,minfo.DVD.LENGTH95,
      minfo.DVD.LENGTH96,minfo.DVD.LENGTH97,minfo.DVD.LENGTH98,minfo.DVD.LENGTH99 
    }

    -- 日本語字幕の選択表示
    if minfo.DVD.SLANG.ja then
      if tonumber(minfo.DVD.ALANG.Count) > 1 or not minfo.DVD.ALANG.ja then
        slangjalist = true
      end
    end
    -- 日本語音声の選択表示
    if minfo.DVD.ALANG.ja and tonumber(minfo.DVD.ALANG.Count) > 1 then
      alangjalist = true
    end

    -- タイトルリスト
    if DVDSortTitleNo then
      dvdres = dvdTitleList1(slangjalist,alangjalist,tonumber(minfo.DVD.LONGEST))
    else
      dvdres = dvdTitleList2(slangjalist,alangjalist,tonumber(minfo.DVD.LONGEST))
    end

  return dvdres
  end


  -- H264 を Mpeg TS にトランスコード(Remux)
  if H264ToMpegTS and minfo.Video.Format == "AVC"
   -- NTSC or 24p(not PAL)?
   and  fr ~= "25" and fr ~= "50" and minfo.Video.Standard ~= "PAL"
   -- CFR?
   and minfo.Video.FrameRate_Mode ~= "VFR"
   -- アスペクト比=16/9 ?
   and minfo.Video.DisplayAspectRatio == "1.778" then

    if minfo.Audio.Format == "AC-3" then
      -- コンテナのみ替える
      return [[

       [$_name_$ (TRANSCODE to AVCHD)]
       mencoder2 "$_in_$" -o "$_out_$"
       -oac copy -ovc copy -of lavf -lavfopts format=mpegts -vf harddup
       ]]
    else
      -- コンテナ替え＋音声を AC-3 に変換
      return [[

       [$_name_$ (TRANSCODE to AVCHD)]
       mencoder2 "$_in_$" -o "$_out_$"
       -oac lavc -ovc copy -of lavf -lavfopts format=mpegts
       -vf harddup -srate 48000 -af lavcresample=48000 -channels 6
       -lavcopts acodec=ac3:abitrate=192
       ]]
    end
  end


  -- 通常のトランスコード
  return [[

   [$_name_$ (TRANSCODE to MPEG-PS)]
   mencoder "$_in_$" -o "$_out_$"
   -oac lavc -ovc lavc -of mpeg -mpegopts format=dvd:tsaf
   -vf ]]..vfs..[[ -srate 48000 -af lavcresample=48000
   -ofps 30000/1001 -channels 6
   -lavcopts vcodec=mpeg2video:vrc_buf_size=1835:vrc_maxrate=9800:vbitrate=5000:keyint=18:vstrict=0:acodec=ac3:abitrate=192:aspect=]]
   ..aspect
end


--[[
*****************************************************
* DVDタイトルリストをタイトル番号、言語選択順に表示 *
*****************************************************
]]
function dvdTitleList1(slangjalist,alangjalist,longestNo)
  local longestdsp = ""
  local dvdtranslist = ""
  for i=1,99 do
    if dvdlength[i] ~= nil then
      -- 再生時間最長タイトルに ★を表示する
      if longestNo == i then longestdsp = " ★" else longestdsp = "" end
      -- 日本語字幕のタイトル
      if slangjalist then
        dvdtranslist =  dvdtranslist
          .."\n[Title:"..i..longestdsp.." (日本語字幕)]\n"
          ..[[mencoder -dvd-device "$_in_$" dvd://]]..i
          ..dvdopt
          .." -slang ja"
      end
      -- 日本語音声のタイトル
      if alangjalist then
        dvdtranslist =  dvdtranslist
          .. "\n[Title:"..i..longestdsp.." (日本語音声)]\n"
          ..[[mencoder -dvd-device "$_in_$" dvd://]]..i
          ..dvdopt
          .." -alang ja -slang ja -forcedsubsonly"
      end
      -- 字幕無しのタイトル
      if slangjalist then
        dvdtranslist =  dvdtranslist
          .."\n[Title:"..i..longestdsp.." (字幕無し)]\n"
          ..[[mencoder -dvd-device "$_in_$" dvd://]]..i
          ..dvdopt
          .. " -forcedsubsonly"
      end
      -- 音声、字幕の選択無しのタイトル
      if slangjalist == false and alangjalist == false then
        dvdtranslist =  dvdtranslist
          .."\n[Title:"..i..longestdsp.."]\n"
          ..[[mencoder -dvd-device "$_in_$" dvd://]]..i
          ..dvdopt
          .. " -forcedsubsonly"
      end
    end
  end
  return dvdtranslist
end

--[[
*****************************************************
* DVDタイトルリストを言語選択、タイトル番号順に表示 *
*****************************************************
]]
function dvdTitleList2(slangjalist,alangjalist,longestNo)
  local longestdsp = ""
  local dvdtranslist = ""

  -- 日本語字幕のタイトル
  if slangjalist then
    for i=1,99 do
      if dvdlength[i] ~= nil then
        -- 再生時間最長タイトルに ★を表示する
        if longestNo == i then longestdsp = " ★" else longestdsp = ""  end
        dvdtranslist =  dvdtranslist
          .."\n[(日本語字幕) Title:"..i..longestdsp.."]\n"
          ..[[mencoder -dvd-device "$_in_$" dvd://]]..i
          ..dvdopt
          .." -slang ja"
      end
    end
  end

  -- 日本語音声のタイトル
  if alangjalist then
    for i=1,99 do
      if dvdlength[i] ~= nil then
        -- 再生時間最長タイトルに ★を表示する
        if longestNo == i then longestdsp = " ★" else longestdsp = ""  end
        dvdtranslist =  dvdtranslist
          .. "\n[(日本語音声) Title:"..i..longestdsp.."]\n"
          ..[[mencoder -dvd-device "$_in_$" dvd://]]..i
          ..dvdopt
          .." -alang ja -slang ja -forcedsubsonly"
      end
    end
  end

  -- 字幕無しのタイトル
  if slangjalist then
    for i=1,99 do
      if dvdlength[i] ~= nil then
        -- 再生時間最長タイトルに ★を表示する
        if longestNo == i then longestdsp = " ★" else longestdsp = ""  end
        dvdtranslist =  dvdtranslist
          .."\n[(字幕無し)Title:"..i..longestdsp.."]\n"
          ..[[mencoder -dvd-device "$_in_$" dvd://]]..i
          ..dvdopt
          .. " -forcedsubsonly"
      end
    end
  end

  -- 音声、字幕の選択無しのタイトル
  if slangjalist == false and alangjalist == false then
    for i=1,99 do
      if dvdlength[i] ~= nil then
        -- 再生時間最長タイトルに ★を表示する
        if longestNo == i then longestdsp = " ★" else longestdsp = ""  end
        dvdtranslist =  dvdtranslist
          .."\n[Title:"..i..longestdsp.."]\n"
          ..[[mencoder -dvd-device "$_in_$" dvd://]]..i
          ..dvdopt
          .. " -forcedsubsonly"
      end
    end
  end

  return dvdtranslist
end
